function [c_star, c0, c1] = threshold_feasibility_check(Cost, c_star, c0, c1)
% threshold_feasibility_check checks whether the graph generated by Cost
% with elements \le c_star can create a perfect matching; if can, c1 =
% c_star; if not, c0 = c_star
%
% Author: Weiyu Huang, whuang@seas.upenn.edu
% version 1
% 2017 Feb 17
% 
% References: W. Huang and A. Ribeiro, Persistent Homology Lower Bounds on
% High Order Network Distances, IEEE Transaction on Signal Processing, vol.
% 65, no. 2, pp. 319-334, January 2017.
%
% W. Huang and A. Ribeiro, Metrics in the Space of High Order Networks,
% IEEE Transaction on Signal Processing, vol. 64, no. 3, pp. 615-629,
% February 2016.

G = Cost.*(Cost > c_star);

if testPerfectMatching(G) % exits perfect matching
    c1 = c_star;
else
    c0 = c_star;

end

